<?xml version='1.0' encoding='ISO-8859-1'?> 
<xsl:stylesheet
version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!--
module :
transformation docbook en un html

source :
/usr/home/fplod/incas/ircaam/ircaam_ws/adm/guides/html.xsl sur aedon.locean-ipsl.upmc.fr

update
$Id$
fplod 2008-10-13T09:15:33Z aedon.locean-ipsl.upmc.fr (Darwin)
-->

<!--
<xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl"/>
-->
<xsl:import href="http://docbook.sourceforge.net/release/xsl/1.73.2/xhtml/docbook.xsl"/>


<xsl:output method="xml"
encoding="utf-8"
indent="yes"
omit-xml-declaration="no"
doctype-public="-//W3C//DTD XHTML 1.1 plus MathML 2.0 plus SVG 1.1//EN"
doctype-system="http://www.w3.org/2002/04/xhtml-math-svg/xhtml-math-svg.dtd"/>

<xsl:template match="pubdate">
  <span class="{name(.)}">
    <xsl:text>svn Id of xml source file : </xsl:text>
    <xsl:apply-templates/>
    <br/>
    <br/>
  </span>
</xsl:template>

<xsl:template name="user.head.content">
<!-- pour palier au manque de xsl:output -->
<meta>
 <xsl:attribute name="http-equiv">Content-Type</xsl:attribute>
 <xsl:attribute name="content">text/html; charset=utf-8</xsl:attribute>
</meta>
 <meta name="robots">
  <xsl:attribute name="content">noindex,nofollow,noarchive</xsl:attribute>
 </meta>
</xsl:template>

</xsl:stylesheet>
